//+------------------------------------------------------------------+
//|                                                   			 		Node |
//|                             Copyright 2006-2011, www.FXmaster.de |
//|                                                  www.FXmaster.de |
//+------------------------------------------------------------------+
#property copyright "Copyright 2006-2011, www.FXmaster.de"
#property link      "www.FXmaster.de"
#property version   "1.00"

#define NIL(p)	(CheckPointer(p)==POINTER_INVALID)

//------------------------------------------------------------------	struct tagWatch
struct tagWatch
{
	string m_name; //  
	string m_val;	// 
};

class CNode; // forward declaration
//------------------------------------------------------------------	class CNodeBase
class CNodeBase
{
public:
	CNode *m_next[]; //  ,    
	CNode *m_prev; //  
	int m_id; //  
	string m_text; // 
	
public:
	CNodeBase() { m_id=0; m_text=""; } // 
	~CNodeBase(); // 
};
//------------------------------------------------------------------	~CNodeInfo
void CNodeBase::~CNodeBase()
{
	for (int i=0; i<ArraySize(m_next); i++) //  
		if (CheckPointer(m_next[i])==POINTER_DYNAMIC) delete m_next[i]; 
	m_prev=NULL; ArrayResize(m_next, 0);
}

//------------------------------------------------------------------	class CNode
class CNode : public CNodeBase
{
public:
	bool m_expand; // c
	bool m_check; //  
	bool m_select; // 
	bool m_edit; // 
	
	//--- run-time 
	int m_uses; //    
	long m_tick; //    
	long m_tick0; //    
	datetime m_last; //    
	tagWatch m_watch[]; //   /
	bool m_break; // -
	int m_brkuse; //      m_uses  m_brkuse

	//---  
	string m_path; //  
	string m_file; //  
	int m_line; //    
	string m_class; //  
	string m_func; //  
	string m_desc; //   

public:
	CNode(); // 
	~CNode(); // 

	void AddWatch(string watch, string val);
};
//------------------------------------------------------------------	CNode
void CNode::CNode()
{
	m_id=0; m_text="";
	m_expand=true; m_check=false; m_select=false; m_edit=false;
	m_desc=""; m_uses=0; m_tick=0; m_tick0=0; m_last=0; m_brkuse=-2;
	m_path=""; m_file=""; m_line=0; m_class=""; m_func="";
}
//------------------------------------------------------------------	~CNode
void CNode::~CNode()
{
	for (int i=0; i<ArraySize(m_next); i++) //  
		if (CheckPointer(m_next[i])==POINTER_DYNAMIC) delete m_next[i]; 
	m_prev=NULL; ArrayResize(m_next, 0);
}
//------------------------------------------------------------------	Watch
void CNode::AddWatch(string name, string val)
{
	int n=ArraySize(m_watch); bool b=false;
	for (int i=0; i<n; i++) if (m_watch[i].m_name==name) { m_watch[i].m_val=val; b=true; break; }
	if (b) return;
	ArrayResize(m_watch, n+1); m_watch[n].m_name=name; m_watch[n].m_val=val;
}
